<template>
  <div>
    <BarChart :chart-data="datacollection" :options="options" :height="300" />
  </div>
</template>

<script>
import BarChart from '@/components/chart/bar.js'
import covertDate from '@/mixins/formateDate'
export default {
  mixins: [covertDate],
  components: {
    BarChart,
  },
  props: {
    setDataDate: Number,
    amountDay: Number,
  },
  data() {
    return {
      datacollection: null,
      setTotalData: [],
      setLabel: [],
      options: null,
      tablesData: [],
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    setDataDate(newVal, oldVal) {
      this.getDataAxios(
        this.setDataDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountDay
      )
    },
    amountDay(newVal, oldVal) {
      this.getDataAxios(
        this.setDataDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountDay
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.setLabel,
        datasets: this.setTotalData,
        borderColor: ['#FFF'],
        borderWidth: 1,
      }
      this.options = {
        plugins: {
          datalabels: {
            formatter: function (value) {
              if(value == 0){
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
        labels: true,
        responsive: true,
        maintainAspectRatio: false,
        height: '250',
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 500,
              },
              stacked: true,
            },
          ],
          xAxes: [
            {
              stacked: true,
            },
          ],
        },
      }
    },
    async getDataAxios(
      timeVal = new Date().getTime(),
      expensestable = 0,
      expensestype = 0,
      amountDay = 0
    ) {
      if (expensestable) {
        const getDate = timeVal
        const amountBar = amountDay

        const dayStart = getDate - 86400000 * Math.floor(amountBar / 2)
        const dayEnd = getDate + 86400000 * Math.floor(amountBar / 2)

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)

        const checkDate = this.onefunction(1, dayEnd, dayStart)
        const changeDate = this.formateDate(dataRes, dayEnd, dayStart)

        const countTypeName = expensestype.map((x) => x.name).length

        const getArray = this.setArray(
          dataRes,
          countTypeName,
          amountBar,
          checkDate
        )
        const getObject = this.setObject(getArray, countTypeName, expensestype)

        this.setTotalData = getObject
        this.setLabel = changeDate

        this.fillData()
      }
    },
    setArray(objData, coutName, amountBar, checkDate) {
      const arrayDeserts = new Array(coutName)
      for (let i = 0; i < arrayDeserts.length; i++) {
        arrayDeserts[i] = new Array(2)
      }
      // Loop to initilize 2D array elements.
      for (let i = 0; i < coutName; i++) {
        for (let j = 0; j < amountBar; j++) {
          objData.forEach((res) => {
            if (res.id - 1 == i) {
              if (checkDate[j] == res.date) {
                arrayDeserts[i][j] = res.price
              }
            }
          })
          if (arrayDeserts[i][j] == null) {
            arrayDeserts[i][j] = ''
          }
        }
      }
      return arrayDeserts
    },
    setObject(arrayData, countName, typeName) {
      let dataArray = []
      for (let i = 0; i < countName; i++) {
        const dataSet = {
          label: typeName[i].name,
          backgroundColor: this.bgColor(i),
          borderColor: ['#FFF'],
          data: arrayData[i],
        }
        dataArray = [...dataArray, dataSet]
      }
      return dataArray
    },
  },
}
</script>
